<template>
  <div>
    <div class="btn-action-container">
      <img
        :src="asset('images/ui_elements/ic_info.png')"
        alt="icon info"
        class="btn-action bg-white rounded-circle"
        @click="showModal()"
      >
    </div>
    <b-modal
      id="modal1"
      hide-footer
      hide-header
      centered
      ref="thisModal"
      class="border-0"
      size="lg"
    >
      <div class="container" v-if="transaction">
        <div class="row mb-2">
          <div class="col-6">
            <h5>Transaction Detail</h5>
          </div>
          <div class="col-6">
            <img
              :src="asset(`images/ui_elements/ic_close.png`)"
              style="width:25px"
              @click="hideModal"
              class="float-right"
            >
          </div>
        </div>
        <div class="row">
          <div class="col-12">
            <b-tabs pills content-class="btab-content">
              <b-tab title-link-class="capsule" title="General" active>
                <form class="form-material" @submit.prevent="submitForm">
                  <div class="form-row">
                    <div class="form-group col-12">
                      <label>Transaction No.</label>
                      <input
                        type="text"
                        class="form-control"
                        readonly
                        v-model="transaction.transactionNo"
                      >
                    </div>
                    <div class="form-group col-6">
                      <label>Name</label>
                      <input type="text" class="form-control" v-model="transaction.userName">
                    </div>

                    <div class="form-group col-6">
                      <label>Email</label>
                      <input type="text" class="form-control" v-model="transaction.userEmail">
                    </div>
                    <div class="form-group col-6">
                      <label>Description</label>
                      <input type="text" class="form-control" v-model="transaction.description">
                    </div>
                    <div class="form-group col-6">
                      <label>Amount</label>
                      <input
                        type="text"
                        class="form-control"
                        :value="formatCurrency(transaction.amount)"
                      >
                    </div>
                    <div class="form-group col-6">
                      <label>Fee</label>
                      <input
                        type="text"
                        class="form-control"
                        :value="formatCurrency(transaction.fee)"
                      >
                    </div>

                    <div class="form-group col-6">
                      <label>Operator</label>
                      <input type="text" class="form-control" v-model="transaction.operator">
                    </div>
                    <div class="form-group col-6">
                      <label>Status</label>
                      <input type="text" class="form-control" v-model="transaction.status">
                    </div>

                    <div class="form-group col-6">
                      <label>Created At</label>
                      <input
                        type="text"
                        class="form-control"
                        v-model="transaction.longDate"
                        readonly
                      >
                    </div>
                    <!-- <button type="submit" class="btn btn-primary form-control capsule">
                    <span v-if="loading">
                      Updating
                      <i class="fas fa-circle-notch fa-spin"></i>
                    </span>
                    <span v-else>Save</span>
                    </button>-->
                  </div>
                </form>
              </b-tab>
              <b-tab title-link-class="capsule" title="Detail">
                <div v-if="loading">
                  <vue-content-loading :width="300" :height="100">
                    <rect x="0" y="0" rx="4" ry="4" width="50" height="15"/>
                    <rect x="55" y="0" rx="4" ry="4" width="50" height="15"/>
                    <rect x="0" y="20" rx="2" ry="2" width="150" height="15"/>
                    <rect x="155" y="20" rx="2" ry="2" width="150" height="15"/>
                    <rect x="0" y="40" rx="2" ry="2" width="150" height="15"/>
                    <rect x="155" y="40" rx="2" ry="2" width="150" height="15"/>
                    <rect x="0" y="60" rx="2" ry="2" width="150" height="15"/>
                    <rect x="155" y="60" rx="2" ry="2" width="150" height="15"/>
                    <rect x="0" y="80" rx="2" ry="2" width="150" height="15"/>
                    <rect x="155" y="80" rx="2" ry="2" width="150" height="15"/>
                  </vue-content-loading>
                </div>
                <form class="form-material" v-else @submit.prevent="submitForm">
                  <div class="form-row">
                    <template v-for="(value,index) in transaction.detail">
                      <div v-if="isObject(value)" :key="index" class="col-12">
                        <table class="table table-bordered table-striped">
                          <tr>
                            <td colspan="2" class="bg-light text-capitalize">
                              <b>{{index}}</b>
                            </td>
                          </tr>
                          <tr v-for="(objValue,objIndex) in value" :key="objIndex">
                            <td>{{objIndex}}</td>
                            <td>{{shouldFormat(objIndex,objValue)}}</td>
                          </tr>
                        </table>
                      </div>
                      <div class="form-group col-6" :key="index" v-else>
                        <label>{{index}}</label>
                        <input type="text" class="form-control" :value="shouldFormat(index,value)">
                      </div>
                    </template>
                  </div>
                </form>
              </b-tab>
            </b-tabs>
          </div>
        </div>
      </div>
    </b-modal>
  </div>
</template>
<script>
import VueContentLoading from "vue-content-loading";
import FormatMixin from "@/mixins/FormatMixin";
export default {
  mixins: [FormatMixin],
  props: ["transaction", "loading"],
  components: { VueContentLoading },
  methods: {
    hideModal() {
      this.$refs.thisModal.hide();
    },
    showModal() {
      this.$emit("show");
      this.$refs.thisModal.show();
    },
    isObject(value) {
      return _.isObject(value);
    },
    shouldFormat(index, value) {
      if (_.isObject(value)) {
        return JSON.stringify(value);
      }
      switch (index) {
        case "amount":
          return this.formatCurrency(value);
          break;
        case "cogs_amount":
          return this.formatCurrency(value);
          break;

        default:
          return value;
          break;
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.btab-content {
  max-height: 80vh;
  overflow-y: scroll;
}
</style>
